:connect   -- Your Server 
:setvar InstallDIR 	  -- Your scripts folder 
GO
USE AW2014
GO
-------------------------------------------------------------------------------------------------
PRINT 'DESTROY PROCS & FUNCTIONS'
DECLARE @SQL VARCHAR(MAX)
DECLARE @CRLF CHAR(2)=CHAR(13)+CHAR(10)
SELECT @SQL = COALESCE(@SQL+';'+@CRLF,'')
+	'DROP '
+	CASE type
		WHEN 'FN' THEN 'FUNCTION '
		WHEN 'P' THEN 'PROC '
	END
+ OBJECT_SCHEMA_NAME(object_id)+'.'+OBJECT_NAME(object_id)
FROM sys.objects
WHERE type IN ('FN','P')
AND OBJECT_SCHEMA_NAME(object_id) IN ('Validate','CandidateKey')
ORDER BY type DESC
PRINT @SQL
EXEC(@SQL)
GO
-------------------------------------------------------------------------------------------------
PRINT 'DESTROY Views'
DECLARE @SQL VARCHAR(MAX)
DECLARE @CRLF CHAR(2)=CHAR(13)+CHAR(10)
SELECT @SQL = COALESCE(@SQL+';'+@CRLF,'')
+	'DROP '
+	CASE type
		WHEN 'V' THEN 'VIEW '
	END
+ OBJECT_SCHEMA_NAME(object_id)+'.'+OBJECT_NAME(object_id)
FROM sys.objects
WHERE type IN ('V')
AND OBJECT_SCHEMA_NAME(object_id) IN ('Validate','CandidateKey')
ORDER BY type DESC
PRINT @SQL
EXEC(@SQL)
GO
-------------------------------------------------------------------------------------------------
PRINT 'DESTROY TABLES'
DECLARE @SQL VARCHAR(MAX)
DECLARE @CRLF CHAR(2)=CHAR(13)+CHAR(10)
SELECT @SQL = COALESCE(@SQL+';'+@CRLF,'')
+	'DROP '
+	CASE type
		WHEN 'U' THEN 'TABLE '
	END
+ OBJECT_SCHEMA_NAME(object_id)+'.'+OBJECT_NAME(object_id)
FROM sys.objects
WHERE type IN ('U')
AND OBJECT_SCHEMA_NAME(object_id) IN ('Validate','CandidateKey')
ORDER BY type DESC
PRINT @SQL
EXEC(@SQL)
GO
-------------------------------------------------------------------------------------------------
:r $(InstallDIR)01_GenerateSupportingSchemas.sql
:r $(InstallDIR)02_GenerateSupportingTables.sql
:r $(InstallDIR)03_GenerateSupportingViews.sql
:r $(InstallDIR)04_GenerateSupportingTypes.sql
:r $(InstallDIR)04a_GenerateSupportingFunctions.sql
:r $(InstallDIR)05_GenerateSupportingProcs.sql
